 #-*- coding: latin-1 -*-
 #Algoritmid ja andmestruktuurid
 #Kodut nr 8
 #Autor: Ott Rebane (ige pisut lisatud: Jri Kiho)
 #Pealkiri: pikima yhissone algoritmide v6rdlus
 #lesande kirjeldus:
 #8-3a. Realiseerida programmidena nii algoritm joonisel 5.7 kui ka funktsioonil kavandada()
 #phinev algoritm. Vrrelda lahendamise kiirusi nidete phjal. Kui pikkade snede korral
 #vtab esimene programm juba vga kaua aega (rohkem kui 15 sek)?
 #8-3b. Realiseerida funktsioonil kavandada() phinev algoritm, tiendades programmi nii, et leitaks kahe
 #antud sne kik pikimad hissned. Kas suvalise sne s ja reverse(s) pikimate hissnede
 #seas leidub kindlasti palindroom?
 #Kommentaar: Kahjuks ei suutnud 8-3b jaoks vlja melda htki kiiret viisi kikide pikimate hissnede leidmiseks.
 #Tundub, et oma pikima hissne leidmine toimub keerukusega O(m*n) ainult siis, kui on vaja leida hte suvalist
 #pikimat osasnet. Kui on kiki vaja leida, siis peab mlukasutust oluliselt suurendama vi -- nagu mina tegin --
 #raiskama aega jlle kikide vimalike teede lbikimisele maatriksis c. Praegu tundub, et 8-3b algoritm on limalt
 #aeglane -- vrreldav vib-olla 8-3a funktsiooniga P.
 #ldine kommentaar: Pikima osasne leidmine klab nagu 'longest common subSTRING problem'. Klaks vib-olla paremini,
 #kui seda nimetada pikima osajrjendi (vms) leidmiseks 'longest common subSEQUENCE problem'. Aga see on
 #lesande sisu koha pealt ebaoluline krvalmrkus.
__version__ = "3.1" 
def P(s,t):
         #Antud: sned s ja t
         #Tulemus: nende pikim hissne (eksponentsiaalse keerukusega algoritm)
        if (len(s) == 0) or (len(t) == 0):
                return "" 
        if (s[-1].lower() == t[-1].lower()):
                return str(P(s[:-1],t[:-1])) + str(s[-1]) 
        u1 = P(s[:-1], t[:]) 
        u2 = P(s[:],t[:-1]) 
        if len(u1) > len(u2):
                return u1 
        else:
                return u2 
def kavandada(s,t):
         #Antud: sned s ja t
         #Tulemus: tagastatakse nende pikim hissne
        c = [] 
        for i in range(len(s)+1):
                c.append([]) 
                for j in range(len(t)+1):c[i].append(0) 
        for i in range(len(s)):
                for j in range(len(t)):
                        if s[i] == t[j]:c[i+1][j+1] = c[i][j] + 1 
                        else:
                                if c[i][j+1] > c[i+1][j]:c[i+1][j+1] = c[i][j+1] 
                                else:c[i+1][j+1] = c[i+1][j] 
        tulem = "" 
        m = len(s) 
        n = len(t) 
        element = c[m][n] 
        while (element != 0):
                if c[m-1][n] == element:
                        element = c[m-1][n] 
                        m -= 1 
                elif c[m][n-1] == element:
                        element = c[m][n-1] 
                        n -= 1 
                else:
                        tulem = s[m-1] + tulem 
                        element = c[m-1][n-1] 
                        m -= 1 
                        n -= 1 
        return tulem 
print ("TEST 8-3a:") 
s = "Ouagadougou i" 
t = "Burkina Faso i" 
print ("Sne s on: ",s) 
print ("Sne t on: ",t) 
print ("Pikim hissne eksponentsiaalse algoritmiga:",str(P(s,t))) 
print ("Umbkaudu 15 thte on selle algoritmi jaoks juba liiga pikk sna.") 
print ("Dnaamilise kavandamise meetodiga saame hissneks:",str(kavandada(s,t))) 
s = "How much wood would a woodpecker peck if a woodpecker would peck wood." 
t = "Too much work and fun makes oy." 
print ("Nd vtame snedeks:") 
print ("s on ",s) 
print ("t on ",t) 
print ("Pikim hissne on:") 
print(str(kavandada(s,t))) 
def kavandada2(s,t):
         #Antud:
         #Tulemus: maatriks c tidetud pikima hissne pikkust nitava maatriksiga
        c = [] 
        for i in range(len(s)+1):
                c.append([]) 
                for j in range(len(t)+1):c[i].append(0) 
        for i in range(len(s)):
                for j in range(len(t)):
                        if s[i] == t[j]:c[i+1][j+1] = c[i][j] + 1 
                        else:
                                if c[i][j+1] > c[i+1][j]:c[i+1][j+1] = c[i][j+1] 
                                elif c[i][j+1] < c[i+1][j]:c[i+1][j+1] = c[i+1][j] 
                                else:c[i+1][j+1] = c[i+1][j] 
        tulem = "" 
        m1 = len(s) 
        n1 = len(t) 
        sone = [] 
        def k6ikS6ned(m,n):
                 #Antud: snede s ja t indeksid m ja n
                 #Tulemus: jrjend pikimatest osasnedest
                if (m == 0) or (n == 0):
                        return [""] 
                elif s[m-1] == t[n-1]: #leitud samad smbolid
                        jada = [] 
                        for Z in k6ikS6ned(m-1,n-1): #vaatame kik prefikssned lbi
                                jada.append(str(Z) + s[m-1])  
                        return jada 
                else:
                        jada = [] 
                        jada2 = [] 
                        if c[m][n-1] >= c[m-1][n]:jada = k6ikS6ned(m,n-1) 
                        if c[m-1][n] >= c[m][n-1]:
                                jada2 =k6ikS6ned(m-1,n) 
                                for s6ne in jada2:
                                        if s6ne not in jada:jada.append(s6ne) 
                        return jada 
        return k6ikS6ned(m1,n1) 
print ("\n\nTEST 8-3b") 
print ("Snede s ja t korral on pikima(te)ks hissne(de)ks:") 
print (kavandada2(s,t)) 
a = "abcdefghij" 
b = "baedcjihgf" 
print ("\n\nSnede ",a," ja ",b," korral:") 
print (kavandada2(a,b)) 
c = "aeglanealgoritm" 
#c = "regrautasuvol" 
d = c[::-1] #reverse c
print ("\n\nVaatleme sne ja tagurpidi sne pikimaid osasnesid. \nKas seal leidub alati palindroom?") 
print ("Sne on  :",c) 
print ("Tagurpidi:",d) 
print ("Pikimad osasned:",kavandada2(c,d)) 
print ("Vastaksin (testuseta) JAH - \nnimetatud tingimustel on alati pikimate osasnede seas palindroom.") 
print() #JK
s = '1524332451'  
t = '1542334251' 
print ("Sne on  :", s) 
print ("Tagurpidi:", t) 
print ("Pikimad osasned:",kavandada2(s, t)) 
print ("Jarelikult PY seas vib leiduda ka mitte-palindroome.") 
